/*
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Contributors:
 *    Timon Veenstra <monezz@gmail.com> - initial API and implementation and/or initial documentation
 */
package nl.cloudfarming.client.imp;

import java.util.HashSet;
import java.util.Set;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.MultiDataObject;
import org.openide.loaders.MultiFileLoader;
import org.openide.util.Lookup;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;
import org.openide.util.lookup.ProxyLookup;

/**
 *
 * @author Timon Veenstra <monezz@gmail.com>
 */
public abstract class ImportDataObject extends MultiDataObject {

    protected InstanceContent ic;
    private AbstractLookup intern;

    public ImportDataObject(final FileObject fo, final MultiFileLoader loader) throws DataObjectExistsException {
        super(fo, loader);
        ic = new InstanceContent();
        intern = new AbstractLookup(this.ic);
        ImportProcessor importProcessor = ImportProcessor.Locator.locate(fo);
        if (importProcessor != null){
            ic.add(importProcessor);
        }

        ic.add(new ImportSource() {

            @Override
            public Set<FileObject> getFiles() {
                return files();
            }
        });
    }

    @Override
    public Lookup getLookup() {
        return new ProxyLookup(super.getLookup(), intern);
    }

}
